jQuery(document).ready(function($){

	// Tabs

	$('#tabs a').click(function (e) {
		e.preventDefault();
		$(this).tab('show');
	});

	// ToolTip

	$('[data-toggle="tooltip"]').tooltip();

	// Define the variables

	var license_activate_button = '<span class="btn btn-primary ' +
		nnr_rlp_data.prefix_dash + 'activate-license">' +
		nnr_rlp_data.activate_text + '</span>';

	var license_deactivate_button = '<span class="btn btn-default ' +
		nnr_rlp_data.prefix_dash + 'deactivate-license">' +
		nnr_rlp_data.deactivate_text + '</span>';

	var check = '<span class="fa fa-check form-control-feedback" aria-hidden="true"></span>';
	var error = '<span class="fa fa-times form-control-feedback" aria-hidden="true"></span>';
	var spinner = '<i class="' + nnr_rlp_data.prefix_dash + 'license-key-status fa fa-spinner fa-spin form-control-feedback"></i>';

	// Check license key

	if ( $('.' + nnr_rlp_data.prefix_dash + 'license-key').val() != '' ) {

		$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(spinner);

		var data = {
			'action': 'nnr_rlp_license_action',
			'license_action': 'check_license',
			'license_key': $('.' + nnr_rlp_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
			$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
			$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

			if ( response == 'valid' ) {

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').addClass(nnr_rlp_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append(license_deactivate_button);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.activation_valid + '</em>');

			}  else if ( response == 'expired' ) {

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').addClass(nnr_rlp_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.expired + '</em>');

			} else {

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').addClass(nnr_rlp_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.activation_error + '</em>');

			}

			console.log(response);
		});
	} else {
		$('.' + nnr_rlp_data.prefix_dash + 'license-key').addClass(nnr_rlp_data.prefix_dash + 'license-key-valid');
		$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(error);
		$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').addClass('has-error');

		$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
		$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.no_license_key + '</em>');
	}

	// Activate License

	$(document).on('click', '.' + nnr_rlp_data.prefix_dash + 'activate-license', function(){

		$('.' + nnr_rlp_data.prefix_dash + 'activation-message').remove();
		$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
		$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(spinner);
		$('.' + nnr_rlp_data.prefix_dash + 'activate-license').remove();
		$('.' + nnr_rlp_data.prefix_dash + 'deactivate-license').remove();
		$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
		$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

		var data = {
			'action': 'nnr_rlp_license_action',
			'license_action': 'activate_license',
			'license_key': $('.' + nnr_rlp_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();

			if ( response == 'valid' ) {

				$('.alert').remove();

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').addClass(nnr_rlp_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append(license_deactivate_button);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.activation_valid + '</em>');

			} else {

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').addClass(nnr_rlp_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.activation_error + '</em>');

			}

			console.log(response);
		});

	});

	// Deactivate License

	$(document).on('click', '.' + nnr_rlp_data.prefix_dash + 'deactivate-license', function(){

		$('.' + nnr_rlp_data.prefix_dash + 'activation-message').remove();
		$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
		$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(spinner);
		$('.' + nnr_rlp_data.prefix_dash + 'activate-license').remove();
		$('.' + nnr_rlp_data.prefix_dash + 'deactivate-license').remove();
		$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
		$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

		var data = {
			'action': 'nnr_rlp_license_action',
			'license_action': 'deactivate_license',
			'license_key': $('.' + nnr_rlp_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();

			if ( response == 'deactivated' ) {

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').val('');
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				///$('.' + nnr_rlp_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.deactivation_valid + '</em>');

			} else if ( response == 'failed' ) {

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.deactivation_error + '</em>');

			} else {

				$('.' + nnr_rlp_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_rlp_data.prefix_dash + 'activation-message">' + nnr_rlp_data.deactivation_error + '</em>');
			}

			console.log(response);
		});

	});

	// Clear Cache button

	$('input[name="clear-cache"]').click(function(e){
		e.preventDefault();
		var result = confirm('Are you sure you want to clear the related posts cache?');
	    if (result == true) {

		    $('input[name="clear-cache"]').parent().append('<i class="fa fa-spinner fa-spin"></i>');

	        $.post(nnr_rlp_data.ajaxurl, {
				'action': 'nnr_rlp_clear_cache'}, function(response) {

				$('input[name="clear-cache"]').parent().find('.fa-spin').remove();

				console.log('Cache Cleared.');
			});
	    }
	});

	// Default Thumbnail

	$('#' + nnr_rlp_data.prefix_dash + 'default-thumbnail-btn').click(function(e) {
	    e.preventDefault();

		var custom_uploader = wp.media()

	    .on('select', function() {
	        var attachment = custom_uploader.state().get('selection').first().toJSON();
	        $('#' + nnr_rlp_data.prefix_dash + 'default-thumbnail-show').css('background-image', 'url(' + attachment.url + ')');
	        $('#' + nnr_rlp_data.prefix_dash + 'default-thumbnail').val(attachment.id);
	    })
	    .open();
	});

	$('#' + nnr_rlp_data.prefix_dash + 'default-thumbnail-btn-remove').click(function(){
		$('#' + nnr_rlp_data.prefix_dash + 'default-thumbnail-show').css('background-image', '');
	    $('#' + nnr_rlp_data.prefix_dash + 'default-thumbnail').val('');
	});

	// Layout example

	$("#" + nnr_rlp_data.prefix_dash + "layout").on('change', function(){
	    $("." + nnr_rlp_data.prefix_dash + "layout-example").attr('src', nnr_rlp_data.plugins_url + $(this).val() + '.png');
	}).trigger('change');

	// Order By Description

	$("#" + nnr_rlp_data.prefix_dash + "order-by").on('change', function(){
	    var $selected = $(this).find(':selected');
	    $("." + nnr_rlp_data.prefix_dash + "orderby-description").attr('data-original-title', $selected.data('description'));
	}).trigger('change');

	// Related By Description

	$("#" + nnr_rlp_data.prefix_dash + "related-by").on('change', function(){
	    var $selected = $(this).find(':selected');
	    $("." + nnr_rlp_data.prefix_dash + "related-by-description").attr('data-original-title', $selected.data('description'));
	}).trigger('change');

	// Hide and show all settings

	$('.' + nnr_rlp_data.prefix_dash + 'post-type').hide();

	if ( $('#' + nnr_rlp_data.prefix_dash + 'display-in').val() == 'all' ) {
		$('.' + nnr_rlp_data.prefix_dash + 'post-type').show();
	} else {
		$('.' + nnr_rlp_data.prefix_dash + $('#' + nnr_rlp_data.prefix_dash + 'display-in').val()).show();
	}

	$('#' + nnr_rlp_data.prefix_dash + 'display-in').change(function(){
		$('.' + nnr_rlp_data.prefix_dash + 'post-type').hide();

		if ( $(this).val() == 'all' ) {
			$('.' + nnr_rlp_data.prefix_dash + 'post-type').show();
		} else {
			$('.' + nnr_rlp_data.prefix_dash + $('#' + nnr_rlp_data.prefix_dash + 'display-in').val()).show();
		}
	});

	// Display Location

	$("#" + nnr_rlp_data.prefix_dash + "location").on('change', function(){
		$("." + nnr_rlp_data.prefix_dash + "location").hide();
	    $("." + nnr_rlp_data.prefix_dash + "location-" + $(this).val()).show();

		if ($(this).val() != 'none') {

			$('.' + nnr_rlp_data.prefix_dash + 'post-type').hide();

			if ( $('#' + nnr_rlp_data.prefix_dash + 'display-in').val() == 'all' ) {
				$('.' + nnr_rlp_data.prefix_dash + 'post-type').show();
			} else {
				$('.' + nnr_rlp_data.prefix_dash + $('#' + nnr_rlp_data.prefix_dash + 'display-in').val()).show();
			}

		}

	}).trigger('change');

	// Hide and show color options

	$("." + nnr_rlp_data.prefix_dash + "text-color").hide();

	if ($("input." + nnr_rlp_data.prefix_dash + "style-override").prop('checked')) {
		$("." + nnr_rlp_data.prefix_dash + "text-color").show();
	}

	$("input." + nnr_rlp_data.prefix_dash + "style-override").change(function(){
		$("." + nnr_rlp_data.prefix_dash + "text-color").hide();
		if ( $(this).prop('checked') ) {
			$("." + nnr_rlp_data.prefix_dash + "text-color").show();
		}
	});

	// Hide and show layout options

	$("." + nnr_rlp_data.prefix_dash + "color").hide();
	$("." + nnr_rlp_data.prefix_dash + "fancy-colors").hide();
	$(".selectize-control.nnr-rlp-fancy-colors-selectize").hide();
	$("." + nnr_rlp_data.prefix_dash + "post-meta").hide();
	$("." + nnr_rlp_data.prefix_dash + "comments").hide();
	$("." + nnr_rlp_data.prefix_dash + "grid-size").hide();
	$("." + nnr_rlp_data.prefix_dash + "numbered-list").hide();
	$("." + nnr_rlp_data.prefix_dash + "show-nav").hide();
	$("." + nnr_rlp_data.prefix_dash + "num-of-columns").hide();

	if ($("." + nnr_rlp_data.prefix_dash + "layout").val() == 'image_tile' ||
		$("." + nnr_rlp_data.prefix_dash + "layout").val() == 'colored_tabs'||
		$("." + nnr_rlp_data.prefix_dash + "layout").val() == 'image_flip'||
		$("." + nnr_rlp_data.prefix_dash + "layout").val() == 'inline_card'||
		$("." + nnr_rlp_data.prefix_dash + "layout").val() == 'stacked_card') {

		$("." + nnr_rlp_data.prefix_dash + "color").show();
	}

	if ($("." + nnr_rlp_data.prefix_dash + "layout").val() != 'masonry' && $(this).val() != 'grid') {
		$("." + nnr_rlp_data.prefix_dash + "post-meta").show();
		$("." + nnr_rlp_data.prefix_dash + "comments").show();
	}

	if ($("." + nnr_rlp_data.prefix_dash + "layout").val() == 'grid') {
		$("." + nnr_rlp_data.prefix_dash + "grid-size").show();
		$("." + nnr_rlp_data.prefix_dash + "color").hide();
		$("." + nnr_rlp_data.prefix_dash + "text-color").hide();
	}

	if ($("." + nnr_rlp_data.prefix_dash + "layout").val() == 'masonry' || $(this).val() == 'thumbnail') {
		$("." + nnr_rlp_data.prefix_dash + "color").hide();
		$("." + nnr_rlp_data.prefix_dash + "text-color").hide();
	}

	if ($("." + nnr_rlp_data.prefix_dash + "layout").val() == 'fancy_colors' ||
		$("." + nnr_rlp_data.prefix_dash + "layout").val() == 'colored_tabs') {
		$("." + nnr_rlp_data.prefix_dash + "fancy-colors").show();
		$(".selectize-control.nnr-rlp-fancy-colors-selectize").show();
	}

	if ($("." + nnr_rlp_data.prefix_dash + "layout").val() == 'slider') {
		$("." + nnr_rlp_data.prefix_dash + "show-nav").show();
		$("." + nnr_rlp_data.prefix_dash + "color").hide();
		$("." + nnr_rlp_data.prefix_dash + "text-color").hide();
	}

	if ($("." + nnr_rlp_data.prefix_dash + "layout").val() == 'stacked_card') {
		$("." + nnr_rlp_data.prefix_dash + "num-of-columns").show();
	}

	$("." + nnr_rlp_data.prefix_dash + "layout").change(function(){

		$("." + nnr_rlp_data.prefix_dash + "color").hide();
		$("." + nnr_rlp_data.prefix_dash + "text-color").hide();
		$("." + nnr_rlp_data.prefix_dash + "fancy-colors").hide();
		$(".selectize-control.nnr-rlp-fancy-colors-selectize").hide();
		$("." + nnr_rlp_data.prefix_dash + "post-meta").hide();
		$("." + nnr_rlp_data.prefix_dash + "comments").hide();
		$("." + nnr_rlp_data.prefix_dash + "grid-size").hide();
		$("." + nnr_rlp_data.prefix_dash + "numbered-list").hide();
		$("." + nnr_rlp_data.prefix_dash + "show-nav").hide();
		$("." + nnr_rlp_data.prefix_dash + "num-of-columns").hide();

		if ($("input." + nnr_rlp_data.prefix_dash + "style-override").prop('checked')) {
			$("." + nnr_rlp_data.prefix_dash + "text-color").show();
		}

		if ($(this).val() == 'image_tile' ||
			$(this).val() == 'colored_tabs'||
			$(this).val() == 'image_flip'||
			$(this).val() == 'inline_card'||
			$(this).val() == 'stacked_card') {

			$("." + nnr_rlp_data.prefix_dash + "color").show();
		}

		if ($(this).val() != 'masonry' && $(this).val() != 'grid') {
			$("." + nnr_rlp_data.prefix_dash + "post-meta").show();
			$("." + nnr_rlp_data.prefix_dash + "comments").show();
		}

		if ($(this).val() == 'grid') {
			$("." + nnr_rlp_data.prefix_dash + "grid-size").show();
			$("." + nnr_rlp_data.prefix_dash + "color").hide();
			$("." + nnr_rlp_data.prefix_dash + "text-color").hide();
		}

		if ($(this).val() == 'masonry' || $(this).val() == 'thumbnail') {
			$("." + nnr_rlp_data.prefix_dash + "color").hide();
			$("." + nnr_rlp_data.prefix_dash + "text-color").hide();
		}

		if ($(this).val() == 'fancy_colors' ||
			$(this).val() == 'colored_tabs') {
			$("." + nnr_rlp_data.prefix_dash + "fancy-colors").show();
			$(".selectize-control.nnr-rlp-fancy-colors-selectize").show();
		}

		if ($(this).val() == 'slider') {
			$("." + nnr_rlp_data.prefix_dash + "show-nav").show();
			$("." + nnr_rlp_data.prefix_dash + "color").hide();
			$("." + nnr_rlp_data.prefix_dash + "text-color").hide();
		}

		if ($(this).val() == 'stacked_card') {
			$("." + nnr_rlp_data.prefix_dash + "num-of-columns").show();
		}

	});

	$('.' + nnr_rlp_data.prefix_dash + 'query-exclude').change(function(){

		$('.' + nnr_rlp_data.prefix_dash + 'related-posts-pool').append('<img class="alignnone" src="' + nnr_rlp_data.admin_url + 'images/spinner.gif" width="16" height="16">');

		// Get total number of possible related posts

		var exclude_posts = '';

		$('#' + nnr_rlp_data.prefix_dash + 'display-in option').each(function(){

			if (typeof($('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + $(this).val()).val()) != 'undefined') {
				exclude_posts = $('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + $(this).val()).val() + ',' + exclude_posts;
			}
		});

		var exclude_terms = {};

		$('#' + nnr_rlp_data.prefix_dash + 'list-taxonomies option').each(function(){

			if (typeof($('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + $(this).val()).val()) != 'undefined') {
				exclude_terms[$(this).val()] = $('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + $(this).val()).val();
			}
		});

		$.post(nnr_rlp_data.ajaxurl, {
			'action': 'nnr_rlp_get_related_posts_pool',
			'exclude_posts': exclude_posts,
			'exclude_terms': exclude_terms,
			'time_range': $('#' + nnr_rlp_data.prefix_dash + 'time-range').val(),
			'post_type': $('#' + nnr_rlp_data.prefix_dash + 'query-post-type').val(),}, function(response) {

			$('.' + nnr_rlp_data.prefix_dash + 'related-posts-pool .alignnone').remove();

			$('.' + nnr_rlp_data.prefix_dash + 'possible-related-posts').remove();
			$('.' + nnr_rlp_data.prefix_dash + 'related-posts-pool').append('<div class="' + nnr_rlp_data.prefix_dash + 'related-posts-wrap ' + nnr_rlp_data.prefix_dash + 'possible-related-posts"><div><p>' + response + '</p>Possible Number of Related Posts</div></div><div class="' + nnr_rlp_data.prefix_dash + 'related-posts-wrap ' + nnr_rlp_data.prefix_dash + 'possible-related-posts"><div style="background-color:' + getColorFromPrecent(response/$('.' + nnr_rlp_data.prefix_dash + 'total-related-posts').data('total')) + ';color:white;"><p>' + Math.round( (response/$('.' + nnr_rlp_data.prefix_dash + 'total-related-posts').data('total')) * 10000 )/100 + '%</p>Post Eligibilty</div></div>');
		});

	});

	// Get total number of posts on blog

	$.post(nnr_rlp_data.ajaxurl, {'action': 'nnr_rlp_get_total_posts'}, function(response) {
		$('.' + nnr_rlp_data.prefix_dash + 'related-posts-pool').append('<div class="' + nnr_rlp_data.prefix_dash + 'related-posts-wrap"><div class="' + nnr_rlp_data.prefix_dash + 'total-related-posts" data-total="' + response + '"><p>' + response + '</p>Total Number of Posts</div></div>');

		// Get total number of possible related posts

		var exclude_posts = '';

		$('#' + nnr_rlp_data.prefix_dash + 'display-in option').each(function(){

			if (typeof($('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + $(this).val()).val()) != 'undefined') {
				exclude_posts = $('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + $(this).val()).val() + ',' + exclude_posts;
			}
		});

		var exclude_terms = {};

		$('#' + nnr_rlp_data.prefix_dash + 'list-taxonomies option').each(function(){

			if (typeof($('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + $(this).val()).val()) != 'undefined') {
				exclude_terms[$(this).val()] = $('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + $(this).val()).val();
			}
		});

		$.post(nnr_rlp_data.ajaxurl, {
			'action': 'nnr_rlp_get_related_posts_pool',
			'exclude_posts': exclude_posts,
			'exclude_terms': exclude_terms,
			'time_range': $('#' + nnr_rlp_data.prefix_dash + 'time-range').val(),
			'post_type': $('#' + nnr_rlp_data.prefix_dash + 'query-post-type').val()}, function(response) {

			$('.' + nnr_rlp_data.prefix_dash + 'related-posts-pool').append('<div class="' + nnr_rlp_data.prefix_dash + 'related-posts-wrap ' + nnr_rlp_data.prefix_dash + 'possible-related-posts"><div><p>' + response + '</p>Possible Number of Related Posts</div></div><div class="' + nnr_rlp_data.prefix_dash + 'related-posts-wrap ' + nnr_rlp_data.prefix_dash + 'possible-related-posts"><div style="background-color:' + getColorFromPrecent(response/$('.' + nnr_rlp_data.prefix_dash + 'total-related-posts').data('total')) + ';color:white;"><p>' + Math.round( (response/$('.' + nnr_rlp_data.prefix_dash + 'total-related-posts').data('total')) * 10000 )/100 + '%</p>Post Eligibilty</div></div>');
		});
	});

	function getColorFromPrecent(pct) {

		var percentColors = [
		    { pct: 0.0, color: { r: 0xff, g: 0x00, b: 0 } },
		    { pct: 0.5, color: { r: 0xff, g: 0xff, b: 0 } },
		    { pct: 1.0, color: { r: 0x00, g: 0xff, b: 0 } } ];

	    for (var i = 1; i < percentColors.length - 1; i++) {
	        if (pct < percentColors[i].pct) {
	            break;
	        }
	    }
	    var lower = percentColors[i - 1];
	    var upper = percentColors[i];
	    var range = upper.pct - lower.pct;
	    var rangePct = (pct - lower.pct) / range;
	    var pctLower = 1 - rangePct;
	    var pctUpper = rangePct;
	    var color = {
	        r: Math.floor(lower.color.r * pctLower + upper.color.r * pctUpper),
	        g: Math.floor(lower.color.g * pctLower + upper.color.g * pctUpper),
	        b: Math.floor(lower.color.b * pctLower + upper.color.b * pctUpper)
	    };
	    return 'rgb(' + [color.r, color.g, color.b].join(',') + ')';
	    // or output as hex if preferred
	}

	// Popuplate post types for the Exlude These Post Types setting

	var post_types = [];

	$.each(nnr_rlp_data.post_types, function(index, value){
		post_types.push( {id: value, name: value} );
	});

	$('#' + nnr_rlp_data.prefix_dash + 'query-post-type').selectize({
	  	plugins: ['remove_button'],
	  	valueField: 'id',
		labelField: 'name',
		searchField: 'name',
	  	options: post_types,
	  	onDelete: function(values) {

		  	if ($('#' + nnr_rlp_data.prefix_dash + 'query-post-type').val().indexOf(',') === -1) {
		  		return false;
		  	}

			return true;
		},
  	});

	// Create an easy interface for selecting categories

	$('#' + nnr_rlp_data.prefix_dash + 'list-taxonomies option').each(function(){
	    $.post(nnr_rlp_data.ajaxurl, {'action': 'nnr_rlp_get_terms', 'taxonomy': $(this).val()}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

			var tax_name = '';
		  	var tag_options = [];

		  	$.each(response, function( index, value ) {
			  	tag_options.push( {id: value.term_id, name: value.name} );
			  	tax_name = value.taxonomy;
			});

		  	$('#' + nnr_rlp_data.prefix_dash + 'query-exclude-' + tax_name).selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});
		});
	});

	// Create list of posts for dropdown

	$.post(nnr_rlp_data.ajaxurl, {
			'action': 'nnr_rlp_get_posts',
			'post_type': $('#' + nnr_rlp_data.prefix_dash + 'display-in').val()}, function(response) {

		response = $.parseJSON(response);

		// Create an easy interface for selecting tags

	  	var post_options = [];

	  	$.each(response, function( index, value ) {
		  	post_options.push({id: value.ID, name: value.post_title});

		});

	  	$('.' + nnr_rlp_data.prefix_dash + 'trigger-exclude-' + $('#' + nnr_rlp_data.prefix_dash + 'display-in').val()).selectize({
		  	plugins: ['remove_button'],
		  	valueField: 'id',
			labelField: 'name',
			searchField: 'name',
		  	options: post_options,
	  	});
	});

	// Get all posts for exclude dropdowns

	$('#' + nnr_rlp_data.prefix_dash + 'display-in option').each(function(){

		if ( $(this).val() == 'all' ) {
			return null;
		}

	    $.post(nnr_rlp_data.ajaxurl, {'action': 'nnr_rlp_get_posts', 'post_type': $(this).val()}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

			var post_type = '';
		  	var post_options = [];

		  	$.each(response, function( index, value ) {
			  	post_options.push({id: value.ID, name: value.post_title});
			  	post_type = value.post_type;
			});

		  	$('.' + nnr_rlp_data.prefix_dash + 'trigger-exclude-' + post_type).selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: post_options,
		  	});

		  	$('.' + nnr_rlp_data.prefix_dash + 'query-exclude-' + post_type).selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: post_options,
		  	});
		});
	});

	// Refresh post dorpdown when user selects a different post type

	$('#' + nnr_rlp_data.prefix_dash + 'display-in').change(function() {

		if ( $(this).val() == 'all' ) {
			$('#' + nnr_rlp_data.prefix_dash + 'display-in option').each(function(){

				if ( $(this).val() == 'all' ) {
					return null;
				}

			    $.post(nnr_rlp_data.ajaxurl, {'action': 'nnr_rlp_get_posts', 'post_type': $(this).val()}, function(response) {

					response = $.parseJSON(response);

					// Create an easy interface for selecting tags

					var post_type = '';
				  	var post_options = [];

				  	$.each(response, function( index, value ) {
					  	post_options.push({id: value.ID, name: value.post_title});
					  	post_type = value.post_type;
					});

				  	if (!$('.' + nnr_rlp_data.prefix_dash + 'trigger-exclude-' + post_type).hasClass('selectized')) {
						$('.' + nnr_rlp_data.prefix_dash + 'trigger-exclude-' + post_type).selectize({
						  	plugins: ['remove_button'],
						  	valueField: 'id',
							labelField: 'name',
							searchField: 'name',
						  	options: post_options,
					  	});
					}
				});
			});
		}
	});

	// Fancy Color Picker

	$.each($("input." + nnr_rlp_data.prefix_dash + "fancy-colors-selectize"), function(key, value){

		$('input.' + nnr_rlp_data.prefix_dash + 'fancy-colors-selectize.selectized').hide();

		if (!$(value).hasClass('selectized')) {
			$(value).selectize({
				plugins: ['drag_drop', 'remove_button'],
				valueField: 'hex',
			    labelField: 'name',
			    searchField: 'name',
			    options: [
			       	{hex: '#61BD6D', name: 'Fern'},
			        {hex: '#1ABC9C', name: 'Mountain Meadow'},
			        {hex: '#54ACD2', name: 'Picton Blue'},
			        {hex: '#2C82C9', name: 'Mariner'},
			        {hex: '#9365B8', name: 'Wisteria'},
			        {hex: '#457757', name: 'Chambray'},
			        {hex: '#41A85F', name: 'Chateau Green'},
			        {hex: '#00A885', name: 'Persian Green'},
			        {hex: '#3D8EB9', name: 'Curious Blue'},
			        {hex: '#2969B0', name: 'Denim'},
			        {hex: '#553982', name: 'Blue Gem'},
			        {hex: '#28324E', name: 'Blue Whale'},
			        {hex: '#F7DA64', name: 'Energy'},
			        {hex: '#FBA026', name: 'Neon Carrot'},
			        {hex: '#EB6B56', name: 'Terra Cotta'},
			        {hex: '#E14938', name: 'Cinnabar'},
			        {hex: '#A38F84', name: 'Almond Frost'},
			        {hex: '#EFEFEF', name: 'White Smoke'},
			        {hex: '#FAC51C', name: 'Turbo'},
			        {hex: '#F37934', name: 'Sun'},
			        {hex: '#D14841', name: 'Valencia'},
			        {hex: '#B8312F', name: 'Well Road'},
			        {hex: '#75706B', name: 'Iron Gray'},
			        {hex: '#D1D5D8', name: 'Iron'},
				],
			    onChange: function(){
				    $.each($(".selectize-input .item"), function(key, value){
						$(value).css('background-color', $(value).data('value'));

						if ($(value).data('value') == '#457757' ||
							$(value).data('value') == '#2969B0' ||
							$(value).data('value') == '#553982' ||
							$(value).data('value') == '#28324E' ||
							$(value).data('value') == '#75706B') {
							$(value).css('color', 'white');
						}
					});
			    },
			    render: {
				    option: function(data, escape) {

					    if (data.hex == '#457757' ||
							data.hex == '#2969B0' ||
							data.hex == '#553982' ||
							data.hex == '#28324E' ||
							data.hex == '#75706B') {
							return '<div class="option" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
						}

					    return '<div class="option" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
				    },
				    item : function(data, escape) {

					    if (data.hex == '#457757' ||
							data.hex == '#2969B0' ||
							data.hex == '#553982' ||
							data.hex == '#28324E' ||
							data.hex == '#75706B') {
							return '<div class="item" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
						}

					    return '<div class="item" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
				    }
			    }
			});
		}
	});

	// Background Color Picker

	$('.bg-color-picker').wpColorPicker({
        defaultColor: '#1e73be',
    });

	// Text Color Picker

	$('.color-picker').wpColorPicker({
        defaultColor: '#000000',
    });

	// Numbered List Color Picker

	$('.nl-color-picker').wpColorPicker({
        defaultColor: '#ffffff',
    });

	// Numbered List Box Color Picker

	$('.nl-circle-color-picker').wpColorPicker({
        defaultColor: '#94cd4b',
    });
});